<template>
  <v-container fluid>
    <v-row>
      <v-stepper
        non-linear
        :value="currentStep">
        <v-stepper-header>
          <v-stepper-step
            editable
            :complete="currentStep > 0"
            step="0"
            @click="goToStep(0)"
          >
            INTRO
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 1"
            step="1"
            @click="goToStep(1)"
          >
            SPEED
          </v-stepper-step>

          <v-divider></v-divider>

          <v-stepper-step
            editable
            :complete="currentStep > 2"
            step="2"
            @click="goToStep(2)"
          >
            RATE
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 3"
            step="3"
            @click="goToStep(3)"
          >
            RHYTHM I
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 4"
            step="4"
            @click="goToStep(4)"
          >
            RHYTHM II
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 5"
            step="5"
            @click="goToStep(5)"
          >
            RHYTHM III
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 6"
            step="6"
            @click="goToStep(6)"
          >
            RHYTHM IV
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 7"
            step="7"
            @click="goToStep(7)"
          >
            RHYTHM V
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 8"
            @click="goToStep(8)"
            step="8">
            AXIS
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 9"
            @click="goToStep(9)"
            step="9">
            HYPERTROPHY I
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 10"
            @click="goToStep(10)"
            step="10">
            HYPERTROPHY II
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 11"
            @click="goToStep(11)"
            step="11">
            INFARCTION
          </v-stepper-step>
          <v-divider></v-divider>
          <v-stepper-step
            editable
            :complete="currentStep > 12"
            @click="goToStep(12)"
            step="12">
            CONCLUSION
          </v-stepper-step>
        </v-stepper-header>
        <!-------------------------------CONTENT---------------------------------->
        <!-------------------------------INTRO---------------------------------->
        <v-stepper-items>
          <v-stepper-content step="0">
            <v-card class="step">
              <v-card-title class="text-h2">ECG INTERPRETATION</v-card-title>
              <v-row>
                <v-col cols="7">
                  <v-list class="intro-list">
                    <v-list-item class="text-h3">
                      <v-list-item-icon>
                        <v-icon>
                          mdi-exclamation-thick
                        </v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title class="text-h4 text-wrap">Navigate using the "NEXT" and "PREVIOUS" buttons
                          below or the
                          steps in the header above. You can skip steps.
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-list-item class="text-h3">
                      <v-list-item-icon>
                        <v-icon>
                          mdi-exclamation-thick
                        </v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title class="text-h4 text-wrap">Carefully read the instructions on each step and
                          try
                          to provide
                          the required information, you can edit it at any time.
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-list-item class="text-h3">
                      <v-list-item-icon>
                        <v-icon>
                          mdi-exclamation-thick
                        </v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title class="text-h4 text-wrap">Use the "ECG LEADS" and "WAVES AND INTERVALS" helper
                          charts at the bottom right corner to find out where you need to look at.
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-list-item class="text-h3">
                      <v-list-item-icon>
                        <v-icon>
                          mdi-exclamation-thick
                        </v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title class="text-h4 text-wrap"> If no lead is specified for a sign then it is ok
                          to
                          look for that sign in any lead.
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-list>
                </v-col>
                <v-col>
                  <v-icon
                    :color="rendered ? 'red lighten-2' : 'indigo'"
                    class="mr-12"
                    size="150"
                  >
                    mdi-heart-pulse
                  </v-icon>
                  <v-sparkline v-if="rendered"
                               :value="value"
                               :gradient="gradient"
                               :smooth="radius || false"
                               :padding="padding"
                               :line-width="width"
                               :stroke-linecap="lineCap"
                               :gradient-direction="gradientDirection"
                               :fill="fill"
                               :type="type"
                               :auto-line-width="autoLineWidth"
                               :auto-draw-duration=2400
                               auto-draw
                  ></v-sparkline>
                </v-col>
              </v-row>
            </v-card>
            <!-------------------------------SPEED---------------------------------->
          </v-stepper-content>
          <v-stepper-content step="1">
            <Speed/>
          </v-stepper-content>
          <!-------------------------------RATE---------------------------------->
          <v-stepper-content step="2">
            <Rate/>
          </v-stepper-content>
          <!-------------------------------RHYTHM I---------------------------------->
          <v-stepper-content step="3">
            <RhythmI/>
          </v-stepper-content>
          <!-------------------------------RHYTHM II---------------------------------->
          <v-stepper-content step="4">
            <RhythmII/>
          </v-stepper-content>
          <!-------------------------------RHYTHM III---------------------------------->
          <v-stepper-content step="5">
            <RhythmIII/>
          </v-stepper-content>
          <!-------------------------------RHYTHM IV---------------------------------->
          <v-stepper-content step="6">
            <RhythmIV/>
          </v-stepper-content>
          <!-------------------------------RHYTHM V---------------------------------->
          <v-stepper-content step="7">
            <RhythmV/>
          </v-stepper-content>
          <!-------------------------------AXIS---------------------------------->
          <v-stepper-content step="8">
            <Axis/>
          </v-stepper-content>
          <!-------------------------------HYPERTROPHY I---------------------------------->
          <v-stepper-content step="9">
            <HypertrophyI/>
          </v-stepper-content>
          <!-------------------------------HYPERTROPHY II---------------------------------->
          <v-stepper-content step="10">
            <HypertrophyII/>
          </v-stepper-content>
          <!-------------------------------INFARCTION---------------------------------->
          <v-stepper-content step="11">
            <Infarction/>
          </v-stepper-content>
          <v-stepper-content step="12">
            <Conclusion/>
          </v-stepper-content>
        </v-stepper-items>
      </v-stepper>

      <!-------------------------------Bottom NAV---------------------------------->

    </v-row>
    <v-footer class="bottom-navigation" padless>
      <v-row justify="center" no-gutters>
        <v-col cols="1" class="mr-8">
          <v-btn @click="$store.commit('previous')">Previous</v-btn>
        </v-col>
        <v-col cols="1">
          <v-btn color="primary" @click="$store.commit('next')">Next</v-btn>
        </v-col>
      </v-row>
      <div class="help">
        <v-row justify="space-between" align="center">
          <v-col>
            <v-dialog
              v-model="dialogLeads"
              fullscreen
              transition="dialog-top-transition"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  color="primary"
                  dark
                  v-bind="attrs"
                  v-on="on"
                >
                  ECG LEADS
                </v-btn>
              </template>

              <v-card class="step dialog-overflow" align="center" justify="center">
                <v-row>
                  <v-col>
                    <v-icon>
                      $ECGLeads
                    </v-icon>
                  </v-col>
                </v-row>
                <v-row>
                  <v-col>
                    <v-btn color="primary" dark @click="dialogLeads = false">Close</v-btn>
                  </v-col>
                </v-row>
              </v-card>
            </v-dialog>
          </v-col>
          <v-col>
            <v-dialog
              v-model="dialogWavesIntervals"
              fullscreen
              transition="dialog-top-transition"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  color="primary"
                  dark
                  v-bind="attrs"
                  v-on="on"
                >
                  WAVES AND INTERVALS
                </v-btn>
              </template>

              <v-card class="step dialog-overflow" align="center" justify="center">
                <v-row>
                  <v-col>
                    <img src="../assets/waves.jpg">
                  </v-col>
                </v-row>
                <v-row>
                  <v-col>
                    <v-btn color="primary" dark @click="dialogWavesIntervals = false">Close</v-btn>
                  </v-col>
                </v-row>
              </v-card>
            </v-dialog>
          </v-col>
        </v-row>
      </div>
    </v-footer>
  </v-container>
</template>

<script>
import { mapState } from 'vuex';
import HypertrophyI from '@/components/HypertrophyI.vue';
import HypertrophyII from '@/components/HypertrophyII.vue';
import Axis from '@/components/Axis.vue';
import Rate from '@/components/Rate.vue';
import Speed from '@/components/Speed.vue';
import Infarction from '@/components/Infarction.vue';
import RhythmI from '@/components/RhythmI.vue';
import RhythmII from '@/components/RhythmII.vue';
import RhythmIII from '@/components/RhythmIII.vue';
import RhythmIV from '@/components/RhythmIV.vue';
import RhythmV from '@/components/RhythmV.vue';
import Conclusion from '@/components/Conclusion.vue';

const gradients = [
  ['#222'],
  ['#42b3f4'],
  ['red', 'orange', 'yellow'],
  ['purple', 'violet'],
  ['#00c6ff', '#F0F', '#FF0'],
  ['#f72047', '#ffd200', '#1feaea'],
];
export default {
  name: 'Stepper',
  components: {
    HypertrophyI,
    HypertrophyII,
    Axis,
    Rate,
    Speed,
    Infarction,
    RhythmI,
    RhythmII,
    RhythmIII,
    RhythmIV,
    RhythmV,
    Conclusion,
  },
  data() {
    return {
      dialogLeads: false,
      dialogWavesIntervals: false,
      width: 2,
      radius: 10,
      padding: 8,
      lineCap: 'round',
      gradient: gradients[5],
      value: [0, 0, 0, 0, 2, 0, 0, 0, -3, 15, -7, 0, 0, 2, 3, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, -3, 15, -7, 0, 0, 2, 3, 0, 0, 0, 0, 0, 0],
      line: [0, 0, 0, 0],
      // value: [0, 2, 5, 9, 5, 10, 3, 5, 0, 0, 1, 8, 2, 9, 0],
      gradientDirection: 'top',
      gradients,
      fill: false,
      type: 'trend',
      autoLineWidth: false,
      rendered: false,
      interval: null,
      timeout: null,
    };
  },
  computed: {
    ...mapState([
      'currentStep',
      'maxSteps',
    ]),

    currentStep: {
      get() {
        return this.$store.state.currentStep;
      },
      set(value) {
        this.$store.commit('setCurrentStep', value);
      },
    },

  },
  methods: {
    goToStep(step) {
      this.$store.commit('setCurrentStep', step);
    },
    toggleRendered() {
      this.$data.rendered = !this.$data.rendered;
    },
    heartbeat() {
      this.$data.rendered = true;
      this.timeout = setTimeout(this.toggleRendered, 2100);
    },
  },
  beforeDestroy() {
    clearInterval(this.interval);
    clearTimeout(this.timeout);
  },
  mounted() {
    this.interval = setInterval(this.heartbeat, 2400);
  },
};
</script>
<style scoped>
.intro-list {
  max-width: 80vw;
}

.dialog-overflow {
  overflow-x: hidden
}

.help {
  width: 400px;
  margin-right: 20px;
}

.step {

}

.row {
  margin: 0;
}

.container {
  padding: 0;
}

.bottom-navigation {
  min-height: 7vh;
}

.v-stepper__content {
  min-height: 85vh;
  width: 100vw;
  padding-bottom: 0;
}
</style>
